#include <iostream.h>
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <typeinfo.h>
#include <graphics.h>
#include <fstream.h>
#include "linea.h"
#include "grafo.h"

grafo::grafo()
{
	cout<<"Ha entrado en el contructor grafo sin parametrizar";
   getchar();
}

grafo::grafo(char * fich)
{
	//cout<<"Ha entrado en el contructor grafo parametrizado";
   //getchar();

   linea *lin=new linea();
	char * cadena;

 	fstream fichero(fich,ios::in); 		//Abrimos el fichero fich pasado como parametro, para lectura
	if (!fichero)
	{
   	cout<<"Error al abrir el fichero.";
      getchar();
      exit(1);
   }
   if ((cadena=new char[80])==NULL)
   {
   	cout<<"Error en la reserva de memoria.";
		getchar();
      exit(1);
   }

   cadena[0]='\0';

   int cont=0;
   int ejex,ejey;

   while ((!fichero.eof()) && (cont<8))	//mientras que no termine el fichero y contador<8
   {
      fichero>>cadena;                    //leemos las primeras 7 lneas
   	lin->separar(cadena);              //separamos los campos
      if ((cont==0)||(cont==1))           //Las 2 primeras lineas ...
      	{
         	int campo=atoi(lin->obtener_campo(0));   //.. se transforman a enteros ..
            if (cont==0)	vel_horiz=campo;           //.. se guarda la velocidad horizontal
            if (cont==1)	gasolina=campo;            //.. se guarda la gasolina inicial
         }
      else		//Llenado del vector de monumentos
      	{
         	VN[cont-2]=new char[strlen(lin->obtener_campo(0))+1]; 	//Se reserva memoria para la long. de cadena + 1 (fin de lnea), que se guardar en el vector de nodos
         	strcpy(VN[cont-2],lin->obtener_campo(0));						//Copiamos la cadena del fichero en el vector
            VN[cont-2][strlen(lin->obtener_campo(0))]='\0';       	//Insertamos el fin de linea en la ltima posicin de la cadena
         }
      cont++;
   }


   ejex=0;
   ejey=0;
   while ((!fichero.eof()) && (ejex<MAX)) //Recorremos ejex = lneas del fichero de texto
   	{
   		fichero>>cadena;						//Leemos la lnea
      	lin->separar(cadena);           //Separamos los campos

      	while ((!fichero.eof()) && (ejey<2*MAX))		//Recorremos ejey = campos de una lnea (Calle1,coste1,Calle2,coste2,...)
      		{
               if (strcmp(lin->obtener_campo(ejey),"NULL")!=0)	//Comparamos si el campo CalleN, no es una calle vaca
               	{
                  	M[ejex][ejey/2].nombre_calle=new char[strlen(lin->obtener_campo(ejey))+1];   //Reserva memoria para la cadena
               		strcpy(M[ejex][ejey/2].nombre_calle,lin->obtener_campo(ejey));               //Copiamos el campo CalleN en M(linea,campo/2) ya que las lneas se recorren de 2 en 2.
                     M[ejex][ejey/2].nombre_calle[strlen(lin->obtener_campo(ejey))]='\0';         //Insertamos fin de lnea
                  	M[ejex][ejey/2].longitud=atoi(lin->obtener_campo(ejey+1));                   //Copiamos campo long. en M(lnea,campo/2)
                  }
               else																//Si es una calle vaca
               	{
                  	M[ejex][ejey/2].nombre_calle=new char[strlen(lin->obtener_campo(ejey))+1];   //Reservamos memoria
                  	strcpy(M[ejex][ejey/2].nombre_calle,"NULL");                                  //Copiamos cadena NULL
                     M[ejex][ejey/2].nombre_calle[strlen(lin->obtener_campo(ejey))]='\0';         //Insertamos fin de lnea
                     M[ejex][ejey/2].longitud=-1;                                                  //M(lnea,campo/2).Longitud=-1
                  }
               ejey=ejey+2;	//Incrementamos ejey en dos campos hasta la siguiente calle (Calle1,coste1,Calle2,coste2,Calle3,...)
            }
         ejey=0;	//Volvemos al primer campo
         ejex++;  //Pasamos a la siguiente lnea
      }

   fichero.close();

   p_origen=VN[0];

   delete lin;
   delete cadena;
}

bool grafo::vacio()
{
	cout<<"Comprobando grafo ... "<<endl;
	int i=0;
   int j=0;
   while (i<MAX)
   {
   	while (j<MAX)
      {
      	if (strcmp(M[i][j].nombre_calle,"NULL")!=0)
         	{
            	cout<<" El grafo no esta vacio.";
               return false;
            }
         j++;
      }
      i++;
   }
   cout<<"Grafo vacio."<<endl;
   return true;
}

bool grafo::nuevo_arco(char * origen, char * destino, char * calle, int coste)
{
	bool encontrado_o=false;
   bool encontrado_d=false;
   bool arco=false;
   int i=0;
   int ejex,ejey;
   while (((!encontrado_o)&&(!encontrado_d))||(i<MAX))
   {
   	if ((strcmp(VN[i],origen)==0)&&(!encontrado_o))
      	{
         	ejex=i;
            encontrado_o=true;
      	}
      if ((strcmp(VN[i],destino)==0)&&(!encontrado_d))
      	{
         	ejey=i;
            encontrado_d=true;
         }
      if ((encontrado_o)&&(encontrado_d))
         {
         	cout<<"Se ha creado un nuevo arco entre "<<origen<<" y "<<destino<<endl;
         	M[ejex][ejey].nombre_calle=new char[strlen(calle)+1];   //Reserva memoria para la cadena
            strcpy(M[ejex][ejey].nombre_calle,calle);
            M[ejex][ejey].nombre_calle[strlen(calle)]='\0';         //Insertamos fin de lnea
            M[ejex][ejey].longitud=coste;
            getchar();
            arco=true;
            return arco;
         }
      i++;
   }
   cout<<"No se ha creado el arco ..."<<endl;
   return arco;
}

bool grafo::borrar_arco(char * origen, char * destino)
{
	bool encontrado_o=false;
   bool encontrado_d=false;
   bool borrado=false;
   int i=0;
   int ejex,ejey;
   while (((!encontrado_o)&&(!encontrado_d))||(i<MAX))
   {
   	if ((strcmp(VN[i],origen)==0)&&(!encontrado_o))
      	{
         	ejex=i;
            encontrado_o=true;
      	}
      if ((strcmp(VN[i],destino)==0)&&(!encontrado_d))
      	{
         	ejey=i;
            encontrado_d=true;
         }
      if ((encontrado_o)&&(encontrado_d))
         {
         	cout<<"Arco borrado ..."<<endl;
         	strcpy(M[ejex][ejey].nombre_calle,"NULL");
            M[ejex][ejey].longitud=-1;
            getchar();
            borrado=true;
            return borrado;
         }
      i++;
   }
   cout<<"Arco no encontrado ..."<<endl;
   return borrado;
}

void grafo::pintar_arcos()
{
	//cout<<"Ha entrado en pintar arcos...";
	struct coordenadas
   		{
         	int x;
            int y;
         };
   coordenadas v_centros[6];		//Definicin de un vector de coordenadas constante

   v_centros[0].x=105;
   v_centros[0].y=225;
   v_centros[1].x=235;
   v_centros[1].y=125;
	v_centros[2].x=405;
   v_centros[2].y=125;
	v_centros[3].x=535;
   v_centros[3].y=225;
	v_centros[4].x=405;
   v_centros[4].y=325;
   v_centros[5].x=235;
   v_centros[5].y=325;

	int i,j,x1,y1,x2,y2;

   for (i=0;i<MAX;i++)
   	{
   		for (j=0;j<MAX;j++)
         	{
      			if (existe_arco(VN[i],VN[j]))
         		{
            		x1=v_centros[i].x;
               	y1=v_centros[i].y;
               	x2=v_centros[j].x;
               	y2=v_centros[j].y;
               	line(x1,y1,x2,y2);	//Pinta el arco entre (x1,y1) y (x2,y2)
            	}
            }
      }
}

void grafo::mostrar_arcos()
{
	int ejex,ejey;
   for (ejex=0;ejex<MAX;ejex++)
   	for (ejey=0;ejey<MAX;ejey++)
      	cout<<"Calle: "<<M[ejex][ejey].nombre_calle<<" Distancia: "<<M[ejex][ejey].longitud<<endl;
}

void grafo::mostrar_nodos()
{
	for (int i=0;i<MAX;i++)
   	cout<<"Monumento: "<<VN[i]<<endl;
}

char * grafo::get_nodo(int i)
{
	return VN[i];
}

bool grafo::existe_arco(char * origen, char * destino)
{
	bool encontrado_o=false;
   bool encontrado_d=false;
   bool arco=false;
   int i=0;
   int ejex=0;
   int ejey=0;
   while (((!encontrado_o)&&(!encontrado_d))||(i<MAX))
   {
   	if ((strcmp(VN[i],origen)==0)&&(!encontrado_o))
      	{
         	ejex=i;
            encontrado_o=true;
      	}
      if ((strcmp(VN[i],destino)==0)&&(!encontrado_d))
      	{
         	ejey=i;
            encontrado_d=true;
         }
      if ((encontrado_o)&&(encontrado_d))
         {
         	if (strcmp(M[ejex][ejey].nombre_calle,"NULL")!=0)
            	{
               	//cout<<"Existe un arco entre "<<origen<<" y "<<destino<<endl;
						//getchar();
                  arco=true;
                  return arco;
               }
         }
      i++;
   }
   //cout<<"No existe arco alguno entre "<<origen<<" y "<<destino<<endl;
   //getchar();
   return arco;
}

int grafo::posicion_origen()
{
	for (int i=0; i<MAX; i++)
	 	if (strcmp(VN[i],p_origen)==0)	return i;
}

int grafo::get_vel_horiz()
{
	return vel_horiz;
}

int grafo::get_gasolina()
{
	return gasolina;
}

char * grafo::get_p_origen()
{
	return p_origen;
}

void grafo::set_p_origen(int i)
{
	p_origen=VN[i];
}

char * grafo::get_p_vn(int i)
{
   return VN[i];
}

char * grafo::get_calle(int i, int j)
{
	return M[i][j].nombre_calle;
}

grafo::~grafo()
{
	cout<<"Ha entrado en el destructor grafo";
   getchar();

   for (int ejex=0;ejex<MAX;ejex++)
   	for (int ejey=0;ejey<MAX;ejey++)
      	{
      		 delete M[ejex][ejey].nombre_calle;
         }

   for (int ejex=0;ejex<MAX;ejex++)	delete VN[ejex];
}

